#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_style1 STYLE_DOT

//
//
//
//
//

extern int    MaPeriod       = 20;
extern int    MaMethod       = MODE_SMA;
extern int    MaPrice        = PRICE_TYPICAL;
extern int    AtrPeriod      = 10;
extern double AtrMultiplier1 = 1.2;
extern double AtrMultiplier2 = 2.4;
extern double AtrMultiplier3 = 3.6;
extern bool   UseBuiltInAtr  = true;

//
//
//
//
//

double maBuffer[];
double upBuffer1[];
double upBuffer2[];
double upBuffer3[];
double dnBuffer1[];
double dnBuffer2[];
double dnBuffer3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init() {
   SetIndexBuffer(0, maBuffer);
   SetIndexBuffer(1, upBuffer1);
   SetIndexBuffer(2, dnBuffer1);
   SetIndexBuffer(3, upBuffer2);
   SetIndexBuffer(4, dnBuffer2);
   SetIndexBuffer(5, upBuffer3);
   SetIndexBuffer(6, dnBuffer3);
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      maBuffer[i] = iMA(NULL, 0, MaPeriod, 0, MaMethod, MaPrice, i);
      
         if (UseBuiltInAtr)
               double atr = iATR(NULL,0,AtrPeriod,i);
         else         atr = cATR(AtrPeriod,i);
      
      upBuffer1[i] = maBuffer[i]+atr*AtrMultiplier1;
      dnBuffer1[i] = maBuffer[i]-atr*AtrMultiplier1;
      upBuffer2[i] = maBuffer[i]+atr*AtrMultiplier2;
      dnBuffer2[i] = maBuffer[i]-atr*AtrMultiplier2;
      upBuffer3[i] = maBuffer[i]+atr*AtrMultiplier3;
      dnBuffer3[i] = maBuffer[i]-atr*AtrMultiplier3;
   }
   return (0);
}

//
//
//
//
//

double cATR(int period, int i)
{
   double sum = 0 ;
      for (int k=0; k<period && (i+k)<Bars; k++) sum += High[i+k] - Low[i+k];
   return (sum/k);
}